package scripts;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import jinro.*;

class Initialize {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("Initialize.properties");
	def init() {
		def menu = JinroInterface.userlist.componentPopupMenu;
		def items = menu.components;
		def pos = (0..<items.size()).find { items[it] instanceof JMenuItem && items[it].text == JinroInterface.getTextWithMnemonic("context.random") };
		def notice = setMenuText(new JMenuItem(), "context.notice");
		menu.insert(notice, pos + 1);
		notice.addActionListener([
			actionPerformed: {
				JinroGame.getProperty("GUI").NoticeDialog.newInstance();
			}
		] as ActionListener);
	}
	def setMenuText(item, prop) {
		def text = strings.getString(prop);
		def mnemonic = strings.getString(prop + ".key");
		if(mnemonic.size() == 1 && mnemonic != "&" && !JinroInterface.isMac) {
			if(text.toLowerCase().indexOf(mnemonic.toLowerCase()) < 0) {
				text += "(" + mnemonic + ")";
			}
			item.mnemonic = mnemonic.charAt(0);
		}
		item.text = text;
		return item;
	}
}
