package scripts;

import jinro.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.dnd.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

class NoticeDialog {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("NoticeDialog.properties");
	def NoticeDialog() {
		def dialog = JinroInterface.makeDialog(strings.getString("notice.title"), JinroInterface.mainwindow);
		def actors = [];
		JinroInterface.userlist.selection.toList().each {
			actors << JinroGame.getActor(it.text);
		};
		def composite = new Composite(dialog, SWT.None);
		composite.layoutData = new GridData(GridData.FILL_HORIZONTAL);
		composite.layout = new GridLayout(1, false);
		def label = new Label(composite, SWT.None);
		label.text = strings.getString("notice.messages");
		def text = new Text(composite, SWT.MULTI | SWT.BORDER | SWT.V_SCROLL| SWT.WRAP);
		def txtlayout = new GridData();
		txtlayout.heightHint =220;
		txtlayout.widthHint = 250;
		text.layoutData = txtlayout;
		def radio1 = new Button(composite, SWT.RADIO);
		radio1.text = strings.getString("notice.option.unrepeatable");
		radio1.selection = true;
		def radio2 = new Button(composite, SWT.RADIO);
		radio2.text = strings.getString("notice.option.repeatable");
		def buttons = JinroInterface.makeButtons([strings.getString("dialog.ok"), strings.getString("dialog.cancel")] as String[], dialog);
		buttons[0].addSelectionListener([
			widgetSelected: {
				def messages = [];
				text.text.readLines().findAll{ it }.each {
					messages << it;
				}
				def rnd = new Random((new Date()).time);
				rnd.nextInt();
				if(radio1.selection) {
					(actors.size() - messages.size()).times {
						messages << "";
					}
					Collections.shuffle(messages, rnd);
					actors.size().times { i ->
						if(messages[i]) {
							actors[i].notice(messages[i]);
						}
					}
				} else {
					actors.size().times { i ->
						actors[i].notice(messages[rnd.nextInt(messages.size())]);
					}
				}
				dialog.dispose();
			}
		] as SelectionListener);
		buttons[1].addSelectionListener([
			widgetSelected: {
				dialog.dispose();
			}
		] as SelectionListener);
		dialog.pack();
		JinroInterface.setLocationToCenterParent(dialog);
		dialog.open();
	}
}
