package scripts;

import groovy.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import jinro.*;

class NoticeDialog {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("NoticeDialog.properties");
	def NoticeDialog() {
		def swing = new SwingBuilder();
		def actors = [];
		JinroInterface.userlist.selectedRows.toList().each {
			actors << JinroGame.getActor(JinroInterface.userlist.model.getValueAt(it, 0));
		};
		def dialog;
		def text;
		def unrepeatable;
		def buttons = [
			{ swing.button(text: strings.getString("dialog.ok"), actionPerformed: {
				def messages = text.text.readLines().findAll { it };
				def rnd = new Random((new Date()).time);
				rnd.nextInt();
				if(unrepeatable.selected) {
					(actors.size() - messages.size()).times {
						messages << "";
					}
					println messages;
					Collections.shuffle(messages, rnd);
					actors.size().times { i ->
						if(messages[i]) {
							actors[i].notice(messages[i]);
						}
					}
				} else {
					actors.size().times { i ->
						actors[i].notice(messages[rnd.nextInt(messages.size())]);
					}
				}
				dialog.dispose();
			}) },
			{ swing.button(text: strings.getString("dialog.cancel"), actionPerformed: {
				dialog.dispose();
			}) }
		];
		dialog = swing.dialog(
			owner: JinroInterface.mainwindow,
			title: strings.getString("notice.title"),
			pack: true,
			resizable: false
		) {
			boxLayout(axis: BoxLayout.Y_AXIS)
			panel() {
				flowLayout(alignment: FlowLayout.LEADING, hgap: 5, vgap: 2)
				label(text: strings.getString("notice.messages"))
			}
			panel() {
				flowLayout(alignment: FlowLayout.LEADING, hgap: 5, vgap: 2)
				scrollPane(preferredSize: [250, 220]) {
					text = textArea()
				}
			}
			def group = buttonGroup()
			panel() {
				flowLayout(alignment: FlowLayout.LEADING, hgap: 5, vgap: 1)
				unrepeatable = radioButton(label: strings.getString("notice.option.unrepeatable"), selected: true, buttonGroup: group)
			}
			panel() {
				flowLayout(alignment: FlowLayout.LEADING, hgap: 5, vgap: 1)
				radioButton(label: strings.getString("notice.option.repeatable"), buttonGroup: group)
			}
			panel() {
				flowLayout(alignment: FlowLayout.TRAILING)
				def btns = [];
				if(JinroInterface.isMac || JinroInterface.isGnome) {
					btns[1] = buttons[1]()
					btns[0] = buttons[0]()
				} else {
					btns[0] = buttons[0]()
					btns[1] = buttons[1]()
				}
				def btnsize = [Math.max(btns[0].preferredSize.width, btns[1].preferredSize.width) as int, btns[0].preferredSize.height as int];
				btns.each {
					it.preferredSize = btnsize;
				};
				btns[0].rootPane.defaultButton = btns[0];
			}
		}
		dialog.locationRelativeTo = JinroInterface.mainwindow;
		dialog.visible = true;
	}
}