package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Apostate
// Camp: Foxes

class Apostate extends Civilian {
	def static order = 17;
	def static strings = Civilian.strings.attachBundle("roles/Apostate.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Apostate(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 58;
	}
	// Update priority
	// Returns under 0: target -> it
	// Returns over 0 : it -> target
	def getUpdatePriority(target) {
		if(target.roleIs(new Fox()) || target.roleIs(new Minifox())) {
			return -1;
		} else {
			return 0;
		}
	}
	def getRoleName() {
		return strings.getString("apostate");
	}
	// Notifies the actor of the role.
	def noticeRole() {
		super.noticeRole();
		def actors = JinroGame.getActors();
		actors.findAll{ it.roleIs(new Fox()) }.each {
			notice(strings.getString("notice.fox", it.name, JinroGame.getAlias(it.getRoleName())));
		}
	}
	// Goes to next phase.
	def update() {
		if(JinroGame.time == 0) {
			def foxes = JinroGame.getActors().findAll { (it.roleIs(new Fox()) || it.roleIs(new Minifox())) && it.isLive() };
			if(!foxes) {
				nextstate = State.followed;
				countdown = 1;
			}
		}
		// If there aren't any foxes, the actor dies.
		super.update();
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	def judge(result) {
		return result == 2;
	}
}
