package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Cat
// Camp: Civilians

class Cat extends Civilian {
	def static order = 10;
	def static strings = Civilian.strings.attachBundle("roles/Cat.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = true;		// All roles must define own "bite" property.
	def static isInvisible() {
		return true;
	}
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	Cat(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 30;
	}
	// Update priority
	// Returns under 0: target -> it
	// Returns over 0 : it -> target
	def getUpdatePriority(target) {
		if(target.isWolf()) {
			return 1;
		} else {
			return 0;
		}
	}
	def getRoleName() {
		return strings.getString("cat");
	}
	// When the actor is killed.
	def killed(state) {
		if(state != State.executed) {
			if(state == State.bitten) {
				def actors = JinroGame.getActors();
				def lives = actors.findAll { it.isLive() && it.name != name && it.isWolf() };
				def choice = lives[Math.floor(Math.random() * lives.size()) as int];
				choice.nextstate = State.followed;
				choice.countdown = 1;
			}
			noticeKilled(strings.getString("notice.killed.normal", name));
		} else {
			def actors = JinroGame.getActors();
			def lives = actors.findAll { it.isLive() && it.name != name };
			def choice = lives[Math.floor(Math.random() * lives.size()) as int];
			choice.nextstate = State.followed;
			choice.countdown = 2;
		}
		this.state = state;
		JinroGame.addHistory(this);
	}
}
